diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index b33ccd74b..f0942a236 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -64,25 +64,24 @@ public class PlayerControllerMP extends PlayerController {
 	}
 
 	@Override
-	public boolean useItemOn(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean useOrPlaceItemStackOnTile(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketUseItem(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseItem.TYPE_USE_ITEM_ON));
-		return super.useItemOn(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+		netHandler.addToSendQueue(new PacketUseOrPlaceItemStack(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_USE_OR_PLACE_ON_TILE));
+		return super.useOrPlaceItemStackOnTile(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 	}
 
 	@Override
-	public boolean onlyUseItemStackOn(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean useItemStackOnNothing(Player entityplayer, World world, ItemStack itemstack) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketUseItem(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseItem.TYPE_USE_STACK_ON));
-		return super.onlyUseItemStackOn(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+		netHandler.addToSendQueue(new PacketUseOrPlaceItemStack(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0, PacketUseOrPlaceItemStack.TYPE_USE_ON_NOTHING));
+		return super.useItemStackOnNothing(entityplayer, world, itemstack);
 	}
 
 	@Override
-	public boolean useItem(Player entityplayer, World world, ItemStack itemstack) {
+	public boolean placeItemStackOnTile(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketUseItem(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0, PacketUseItem.TYPE_USE_ITEM));
-		boolean flag = super.useItem(entityplayer, world, itemstack);
-		return flag;
+		netHandler.addToSendQueue(new PacketUseOrPlaceItemStack(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_PLACE_ONLY));
+		return super.placeItemStackOnTile(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 	}
 
 	@Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 6f4ff32c7..79e3b2282 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -514,6 +514,7 @@ public class RenderGlobal
             }
         }
 
+        // DO NOT TURN THIS INTO A FOREACH EITHER
         for (int i = 0, tileEntitiesSize = renderableTileEntities.size(); i < tileEntitiesSize; i++) {
             TileEntity tileEntity = renderableTileEntities.get(i);
             TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, camera, tileEntity, partialTick);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 8655dc88c..875d1a7c9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -151,7 +151,10 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelStandard<>(Blocks.BOOKSHELF_PLANKS_OAK)
             .setTex(BLOCK_TEXTURES, "minecraft:block/bookshelf/top", S_TB)
-            .setTex(BLOCK_TEXTURES, "minecraft:block/bookshelf/side", S_SIDES));
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/bookshelf/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/bookshelf/side", S_SIDES)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/bookshelf/side_retro", S_SIDES)
+        );
 
         addDispatch(new BlockModelWool<>(Blocks.WOOL));
         addDispatch(new BlockModelRope<>(Blocks.ROPE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/rope"));
@@ -271,7 +274,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/limestone"));
         addDispatch(new BlockModelStoneMossy<>(Blocks.MOSS_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/granite"));
 
-        addDispatch(new BlockModelStandard<>(Blocks.SAND).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sand"));
+        addDispatch(new BlockModelStandard<>(Blocks.SAND).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sand").setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/sand_retro"));
         addDispatch(new BlockModelStandard<>(Blocks.GRAVEL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/gravel"));
         addDispatch(new BlockModelStandard<>(Blocks.SULFUR).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sulfur"));
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
index e7100d7f0..30c7370a0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
@@ -16,6 +16,7 @@ import org.useless.dragonfly.models.entity.StaticEntityModel;
 import java.util.HashMap;
 import java.util.Map;
 
+
 public abstract class TileEntityRenderer<T extends TileEntity>
 {
     private final @NotNull Map<@NotNull String, @NotNull StaticEntityModel> modelMap = new HashMap<>();
@@ -26,6 +27,8 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     {
     }
 
+    public void tick() {}
+
     public abstract void doRender(Tessellator tessellator, T tileEntity, double x, double y, double z,
                                   float partialTick);
 
@@ -45,10 +48,6 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     {
     }
 
-    public void tick() {
-
-    }
-
     protected @NotNull StaticEntityModel getModel(@NotNull final String localId) {
         StaticEntityModel model = this.modelMap.get(localId);
         if (model != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 2d32a1086..091088182 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -52,8 +52,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         final Block<?> block = tileEntity.getBlock();
         if (block == null || !(block.getLogic() instanceof BlockLogicSign)) return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
 
-        GL11.glColor4f(1, 1, 1, 1);
-
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 2df4076e4..3c9cfc584 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -73,6 +73,22 @@ public class BlockLogicBasket extends BlockLogic
         return true;
     }
 
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        for (Side s : Side.sides){
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id());
+        }
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data)
+    {
+        for (Side s : Side.sides){
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id());
+        }
+    }
+
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
@@ -83,7 +99,7 @@ public class BlockLogicBasket extends BlockLogic
     {
         TileEntityBasket basketTileEntity = (TileEntityBasket) worldSource.getTileEntity(x, y, z);
         if(basketTileEntity != null){
-            return basketTileEntity.getNumUnitsInside() == basketTileEntity.getMaxUnits();
+            return basketTileEntity.getNumUnitsInside() >= basketTileEntity.getMaxUnits();
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBookshelf.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBookshelf.java
new file mode 100644
index 000000000..dbe050780
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBookshelf.java
@@ -0,0 +1,23 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicBookshelf extends BlockLogic {
+    public BlockLogicBookshelf(Block<?> block, Material material) {
+        super(block, material);
+    }
+
+    @Override
+    public ItemStack @Nullable [] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+//        if (dropCause == EnumDropCause.PISTON_CRUSH) {
+//            return new ItemStack[] {Items.BOOK.getDefaultStack() };
+//        }
+        return super.getBreakResult(world, dropCause, meta, tileEntity);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index a85ea86a9..41c1e5a65 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -233,7 +233,7 @@ public class BlockLogicButton extends BlockLogic implements IPaintable
         }
         if(invalid)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, side, null, null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
index f3f3b3b9f..88bafad85 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
@@ -9,7 +9,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicButtonPainted extends BlockLogicButton implements IPainted{
+public class BlockLogicButtonPainted extends BlockLogicButtonPlanks implements IPainted{
     public static final int MASK_COLOR = 0b1111_0000;
     public BlockLogicButtonPainted(Block<?> block) {
         super(block);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java
new file mode 100644
index 000000000..bdf1b9c63
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Random;
+
+public class BlockLogicButtonPlanks extends BlockLogicButton
+{
+
+    public BlockLogicButtonPlanks(Block<?> block) {
+        super(block);
+    }
+
+    @Override
+    public int tickDelay()
+    {
+        return 10;
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
index d005361f8..f79d6d8c3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCobweb.java
@@ -22,7 +22,7 @@ public class BlockLogicCobweb extends BlockLogic
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
         entity.fallDistance = 0;
-        entity.stuck = true;
+        entity.stuckInCobweb = true;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index ecf05a173..0f000cc75 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -91,6 +91,9 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
         if (connectZNeg) {
             addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - thickness, 0, 0, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
         }
+        if (!connectXPos && !connectXNeg && !connectZPos && !connectZNeg) {
+            addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - thickness, 0, 0.5 - thickness, 0.5 + thickness, 1.5, 0.5 + thickness).move(x, y, z), aabbList);
+        }
     }
 
     //    @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 0473c0cf3..5b66dce3f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -118,16 +118,16 @@ public class BlockLogicFlower extends BlockLogic implements IBonemealable {
             }
 
             label0:
-            for (int i = 0; i < 32; i++) {
+            for (int i = 0; i < 128; i++) {
                 int x = blockX;
                 int y = blockY;
                 int z = blockZ;
                 for (int j = 0; j < i / 16; j++) {
-                    x += rand.nextInt(5) - 2;
-                    y += ((rand.nextInt(5) - 2) * rand.nextInt(3)) / 2;
-                    z += rand.nextInt(5) - 2;
-                    Block<?> b = world.getBlock(x, y - 1, z);
-                    if (b == null || !b.hasTag(BlockTags.GROWS_FLOWERS)) {
+                    x += rand.nextInt(3) - 1;
+                    y += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
+                    z += rand.nextInt(3) - 1;
+                    int blockId = world.getBlockId(x, y - 1, z);
+                    if (!mayPlaceOn(blockId)) {
                         continue label0;
                     }
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
index 8b58a6564..c6832f164 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
@@ -1,6 +1,11 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -18,7 +23,7 @@ public class BlockLogicMushroom extends BlockLogicFlower
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
-        if(rand.nextInt(100) == 0)
+        if(rand.nextInt(25) == 0)
         {
             int x1 = (x + rand.nextInt(3)) - 1;
             int randY = (y + rand.nextInt(2)) - rand.nextInt(2);
@@ -52,4 +57,37 @@ public class BlockLogicMushroom extends BlockLogicFlower
             return world.getFullBlockLightValue(x, y, z) < 13 && mayPlaceOn(world.getBlockId(x, y - 1, z));
         }
     }
+
+    @Override
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        Random rand = world.rand;
+        if (!world.isClientSide && canBeBonemealed) {
+            if (player == null || player.getGamemode().consumeBlocks()) {
+                itemstack.stackSize--;
+            }
+            label0:
+            for (int j1 = 0; j1 < 32; j1++) {
+                int _x = blockX;
+                int _y = blockY;
+                int _z = blockZ;
+                for (int j2 = 0; j2 < j1 / 16; j2++) {
+                    _x += rand.nextInt(3) - 1;
+                    _y += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
+                    _z += rand.nextInt(3) - 1;
+                    if (world.getFullBlockLightValue(_x, _y, _z) >= 13 || !mayPlaceOn(world.getBlockId(_x, _y - 1, _z))) {
+                        continue label0;
+                    }
+                }
+
+                if (world.getBlockId(_x, _y, _z) != 0) {
+                    continue;
+                }
+                if (rand.nextFloat() > 0.85) {
+                    world.setBlockWithNotify(_x, _y, _z, block.id());
+                }
+            }
+            return true;
+        }
+        return canBeBonemealed;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index 73f02c2f2..d8b15d3b8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -6,9 +6,11 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.World;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.List;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
index 7fcb7733c..df35ba8a5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
@@ -1,9 +1,13 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSandstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSandstone.java
new file mode 100644
index 000000000..c8ba42b45
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSandstone.java
@@ -0,0 +1,22 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockLogicSandstone extends BlockLogic {
+    public BlockLogicSandstone(Block<?> block, Material material) {
+        super(block, material);
+    }
+
+    @Override
+    public ItemStack @Nullable [] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        if (dropCause == EnumDropCause.PISTON_CRUSH) {
+            return new ItemStack[] {new ItemStack(Blocks.SAND, world.rand.nextInt(2) + 1)};
+        }
+        return super.getBreakResult(world, dropCause, meta, tileEntity);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index d3ba8da2a..3fc0a62a9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
@@ -23,6 +24,8 @@ public class BlockLogicSpikes extends BlockLogic
     public BlockLogicSpikes(Block<?> block, Material mat)
     {
         super(block, mat);
+        float thickness = 3/16f;
+        this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, thickness, 1.0F);
     }
 
     @Override
@@ -43,24 +46,11 @@ public class BlockLogicSpikes extends BlockLogic
         return new ItemStack[] { new ItemStack(Blocks.SPIKES) };
     }
 
-    @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
-    {
-        return world.canPlaceOnSurfaceOfBlock(x, y -1, z) || world.getBlockId(x, y - 1, z) == Blocks.MOBSPAWNER.id();
-    }
-
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
 		if(world.isClientSide) {
 			return;
 		}
-		
-		boolean destroy = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && world.getBlockId(x, y - 1, z) != Blocks.MESH.id() && world.getBlockId(x, y - 1, z) != Blocks.MOBSPAWNER.id();
-		if(destroy) {
-			dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
-			world.setBlockWithNotify(x, y, z, 0);
-			return;
-		}
 
 		int meta = world.getBlockMetadata(x, y, z);
 		boolean wasPowered = (meta & MASK_POWERED) != 0;
@@ -79,9 +69,9 @@ public class BlockLogicSpikes extends BlockLogic
 
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {	
-    	float f = 1.0f / 16.0f;
-        return AABB.getTemporaryBB(x + f, y, z + f, x + 1 - f, y + 0.1875F, z + 1 - f);
+    {
+        float thickness = 3/16f;
+        return AABB.getTemporaryBB(x, y, z, x + 1,y + thickness, z + 1);
     }
 
     @Override
@@ -90,12 +80,20 @@ public class BlockLogicSpikes extends BlockLogic
         int metaData = world.getBlockMetadata(x, y, z);
         if(isSpikesUp(metaData)) {
             if (entity instanceof Mob) {
-                if(entity.fallDistance > 1.5F) {
-                    entity.hurt(null, (MathHelper.floor(entity.fallDistance) * 2) + 1, DamageType.COMBAT);
-                    entity.stuck = true;
-                } else if (entity.isWalking){
-                    entity.hurt(null, 1, DamageType.COMBAT);
+                // Alt functionality: if player is sneaking, they take half a heart of damage every two seconds, and are not stuck
+                if(entity instanceof Player && entity.isSneaking()){
+                    if(entity.tickCount % 20 == 0){
+                        entity.hurt(null, 1, DamageType.GENERIC);
+                        // Cancel player jump while sneaking
+                    }
+                    entity.yd = 0.0;
+                    return;
+                }
+                // Base functionality: all mobs are dealt one heart of damage every second
+                if(entity.tickCount % 10 == 0) {
+                    entity.hurt(null, 2, DamageType.GENERIC);
                 }
+                entity.stuckInSpikes = true;
             }
         }
     }
